#ifndef _ApplicationHandler_h_
#define _ApplicationHandler_h_

#include "GameTypes.h"
#include "Application.h"
#include "LinkedList.h"

#define	kNumApplications	20

#define	kFinderApp			0
#define kPhotoshopApp		1
#define	kNetscapeApp		2
#define kSimpleText			3
#define	kMacAmp				4
#define	kQuickTime			5


class	ApplicationHandler : 
			public LinkListClass< Application >
{
public:
	ApplicationHandler( void );

	void	HandleMouseClick( Boolean down, point where );
	void	HandleMouseMove( point where );
	void	CleanUp( rect *where );
	
	void	Maintance( void );
	
	void	LoadApplication( uchar what );
	void	KillApplication( Application which );
	
	Boolean	LoadMultipleApps( Boolean what );	// loadm ore then oneo f the same thing
	
	void	SendEventToCurrentApp( ushort event , void *data );
	
	void	SwitchToAppByNum( uchar num );
	
// hiding - showing apps
	void	HideAllButFront( void );
	void	HideFront( void );
	void	ShowAll( void );
	
private:
	void	MakeFrontApp( Application *app );
	void	RealLoadApp( uchar which );
	
	Application		*NewApp( uchar what );
	Boolean			AlreadyLoaded( uchar what );
	
	Application		*finder;
	
	Boolean			multApps;
	
// maintance stuff
	uchar			action;
	
	uchar			whichLoad;
	Application		*whichSwitch;

};


void	ApplicationHandlerInit( void );
extern	ApplicationHandler	AH;

#endif