#ifndef _BogusPhotoshop_h_
#define _BogusPhotoshop_h_

#include "GameTypes.h"
#include "Window.h"
#include "Blitters.h"
#include "Application.h"
#include "MenuItem.h"
#include "FloatWindow.h"
#include "NewWindowWindow.h"
#include "DifferenceCloud.h"

class	BogusPhotoshop : public Application
{
public:
	BogusPhotoshop( void );
	
	Boolean	Init( void );
	
	virtual	void HandleEvent( ushort event , void *data );
	
	virtual	Boolean HandleMouseClick( Boolean down, point where );
	virtual	void 	HandleMouseMove( point where );
	virtual void	CleanUp( rect *where );
	
	virtual void 	Maintance( void );
	
private:
	void			ChangeActive( Boolean act );
	void			SetUpMenuItems( void );
	void			HandleMenuSelect( uchar	which , uchar num );
	
	
	
	
	long			finishSplash;
	FloatWindow		*splash;
	
	NewWindowWindow	*NewWindow;
	Boolean			newWind;
	
	DifferenceCloud	*dc;
	long			dcTime;
	
	// windows
	
	FloatWindow		ToolBar;
	FloatWindow		Navigator;
	FloatWindow		Color;
	FloatWindow		Actions;
	FloatWindow		LayerWindow;
	
	// menu junk
	MenuItem		FileMenu;
	MenuItem		EditMenu;
	MenuItem		ImageMenu;
	MenuItem		LayerMenu;
	MenuItem		SelectMenu;
	MenuItem		FilterMenu;
	MenuItem		ViewMenu;
	MenuItem		WindowMenu;
	
	OffScreenBuff	backGround;
};

#endif