//===================================================================
//=======================  Headers		=============================

#include "MacAmp.h"
#include "ApplicationEvents.h"
#include "MenuBar.h"


//===================================================================
//=======================  Globals		=============================

//===================================================================
//=======================  #define		=============================


//===================================================================
//=======================  Function Prototypes	=====================
void PlayTrack(short track);

/*----------------------------------------------------------------------------\

	MacAmp :: Constructor

\----------------------------------------------------------------------------*/
	MacAmp :: MacAmp( void )
			: Application()
{
	whichApp = 4;
}

/*----------------------------------------------------------------------------\

	MacAmp :: Init

\----------------------------------------------------------------------------*/
Boolean	MacAmp :: Init( void )
{
	Boolean	allGood;
	
	allGood = playList.SetUp( 146 , 194 , 252 ,100 , 100  );
	
	if( allGood )
		allGood = mainthing.SetUp( 145 , 288 , 122 , 100 , 400  );
		
	if( allGood )
	{
		SetUpMenuItems();
		
		AddFrontWindow( &playList );
		AddFrontWindow( &mainthing );
	}
	
	return allGood;
}

/*----------------------------------------------------------------------------\

	MacAmp :: HandleEvent

\----------------------------------------------------------------------------*/
void	MacAmp :: HandleEvent( ushort event , void *data )
{
	switch( event )
	{
	case kAEMakeFrontAppEvent:
		ChangeActive( true );
	break;
	
	case kAEGoBackGroundEvent:
		ChangeActive( false );
	break;
	
	case kAEActivateEvent:
		
	break;
	
	case kAEDeactivateEvent:
		
	break;
	
	case kAEHideEvent:
		
	break;
	
	case kAEMenuSelect:
		HandleMenuSelect( ((AEMenuWhere *)data)->which , ((AEMenuWhere *)data)->num );
	break;
	}
}

/*----------------------------------------------------------------------------\

	MacAmp :: HandleMouseClick

\----------------------------------------------------------------------------*/
Boolean	MacAmp :: HandleMouseClick( Boolean down, point where )
{
	return WMHandleMouseClick( down , where );
}

/*----------------------------------------------------------------------------\

	MacAmp :: HandleMouseMove

\----------------------------------------------------------------------------*/
void	MacAmp :: HandleMouseMove( point where )
{
	WMHandleMouseMove( where );
}

/*----------------------------------------------------------------------------\

	MacAmp :: CleanUp

\----------------------------------------------------------------------------*/
void	MacAmp :: CleanUp( rect *where )
{	
// now clean up the windows
	DrawWindows( where );
}

/*----------------------------------------------------------------------------\

	MacAmp :: Maintance

\----------------------------------------------------------------------------*/
void	MacAmp :: Maintance( void )
{
	WMMaintance();
}

/*----------------------------------------------------------------------------\

	MacAmp :: ChangeActive

\----------------------------------------------------------------------------*/
void	MacAmp :: ChangeActive( Boolean act )
{
	if( act != active )
	{
		active = act;
		
		if( active )
		{
			InitSpecialMenus();
			menuBar.AddMenuToList( &FileMenu );
			menuBar.AddMenuToList( &EditMenu );
			menuBar.AddMenuToList( &WindowMenu );
			
			WMGoBackGround( false );
		}
		else
		{
			WMGoBackGround( true );
		}
	}
}

/*----------------------------------------------------------------------------\

	MacAmp :: SetUpMenuItems

\----------------------------------------------------------------------------*/
void	MacAmp :: SetUpMenuItems( void )
{
	AddMenuWindow( &appleMenu );
	AddMenuWindow( &AppSwitchMenu );
	
	FileMenu.SetWhichMenu( kFileMenuTitle );
	FileMenu.SetMaxItems( 6 );
	FileMenu.AddItem( 0 , "Open MPEG/PlayList" , true );
	FileMenu.AddItem( 1 , "Save Playlist" , true );
	FileMenu.AddItem( 2 , NULL , true );
	FileMenu.AddItem( 3 , "Preferences..." , true );
	FileMenu.AddItem( 4 , NULL , true );
	FileMenu.AddItem( 5 , "Quit" , true );
	FileMenu.Init();
	AddMenuWindow( &FileMenu );
	
	EditMenu.SetWhichMenu( kEditMenuTitle );
	EditMenu.SetMaxItems( 8 );
	EditMenu.AddItem( 0 , "Undo" , false );
	EditMenu.AddItem( 1 , NULL , false );
	EditMenu.AddItem( 2 , "Cut" , false );
	EditMenu.AddItem( 3 , "Copy" , false );
	EditMenu.AddItem( 4 , "Paste" , false );
	EditMenu.AddItem( 5 , "Clear" , false );
	EditMenu.AddItem( 6 , NULL , false );
	EditMenu.AddItem( 7 , "Select All" , false );
	EditMenu.Init();
	AddMenuWindow( &EditMenu );

	WindowMenu.SetWhichMenu( kWindowMenuTitle );
	WindowMenu.SetMaxItems( 2 );
	WindowMenu.AddItem( 0 , "Player" , true );
	WindowMenu.AddItem( 1 , "Play List" , true );
	WindowMenu.Init();
	AddMenuWindow( &WindowMenu );
}

/*----------------------------------------------------------------------------\

	MacAmp :: HandleMenuSelect

\----------------------------------------------------------------------------*/
void	MacAmp :: HandleMenuSelect( uchar	which , uchar num )
{
	switch( which )
	{
	case kFileMenuTitle:
		
	break;
	
	case kEditMenuTitle:
		
	break;
	
	case kWindowMenuTitle:
		PlayTrack( 4 );
	break;
	} 
}

