//===================================================================
//=======================  Headers		=============================

#include "WindowManager.h"


//===================================================================
//=======================  Globals		=============================

//===================================================================
//=======================  #define		=============================


//===================================================================
//=======================  Function Prototypes	=====================

/*----------------------------------------------------------------------------\

	WindowManager :: Constructor

\----------------------------------------------------------------------------*/
	WindowManager :: WindowManager( void )
{
	
}

/*----------------------------------------------------------------------------\

	WindowManager :: Decontructor

\----------------------------------------------------------------------------*/
	WindowManager :: ~WindowManager( void )
{
	
}

/*----------------------------------------------------------------------------\

	WindowManager :: AddNormalWindow

\----------------------------------------------------------------------------*/
void	WindowManager :: AddNormalWindow( Window *w )
{
	normal.AddWindow( w );
}

/*----------------------------------------------------------------------------\

	WindowManager :: AddFrontWindow

\----------------------------------------------------------------------------*/
void	WindowManager :: AddFrontWindow( Window *w )
{
	front.AddWindow( w );
}

/*----------------------------------------------------------------------------\

	WindowManager :: AddMenuWindow

\----------------------------------------------------------------------------*/
void	WindowManager :: AddMenuWindow( Window *w )
{
	menu.AddWindow( w );
}

/*----------------------------------------------------------------------------\

	WindowManager :: RemoveNormalWindow

\----------------------------------------------------------------------------*/
void	WindowManager :: RemoveNormalWindow( Window *w )
{
	normal.RemoveWindow( w );
}

/*----------------------------------------------------------------------------\

	WindowManager :: RemoveFrontWindow

\----------------------------------------------------------------------------*/
void	WindowManager :: RemoveFrontWindow( Window *w )
{
	front.RemoveWindow( w );
}

/*----------------------------------------------------------------------------\

	WindowManager :: WMHandleMouseClick

\----------------------------------------------------------------------------*/
Boolean	WindowManager :: WMHandleMouseClick( Boolean down , point where )
{		
	if( !menu.HandleMouseClick( down , where ) )
		if( !front.HandleMouseClick( down , where ) )
			if( !normal.HandleMouseClick( down , where ) )
			{
				return false;
			}
			
	return true;
}

/*----------------------------------------------------------------------------\

	WindowManager :: WMHandleMouseMove

\----------------------------------------------------------------------------*/
void	WindowManager :: WMHandleMouseMove( point where )
{
	normal.HandleMouseMove( where );
	front.HandleMouseMove( where );
	menu.HandleMouseMove( where );
}

/*----------------------------------------------------------------------------\

	WindowManager :: DrawWindows

\----------------------------------------------------------------------------*/
void	WindowManager :: DrawWindows( rect *where )
{
	normal.DrawAll( where );
	front.DrawAll( where );
	menu.DrawAll( where );
}

/*----------------------------------------------------------------------------\

	WindowManager :: WMMaintance

\----------------------------------------------------------------------------*/
void	WindowManager :: WMMaintance( void )
{

}

/*----------------------------------------------------------------------------\

	WindowManager :: WMGoBackGround

\----------------------------------------------------------------------------*/
void	WindowManager :: WMGoBackGround( Boolean b )
{
	normal.SetBackGround( b );
	front.SetBackGround( b );
	menu.SetBackGround( b );
}

